/*
** Module   : Sensitive.java
** Abstract : An interface for holding the sensitive attribute related methods.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 CS  20130204 Created initial version.
*/

package com.goldencode.p2j.util;
/**
 * Provide access to the SENSITIVE handle attribute
 *
 */
public interface Sensitive
{
   
   /**
    * Java implementation for getting the  SENSITIVE  attribute which
    * contains a <code>logical</code> value that tells if the handle can 
    * receive focus or events.
    * <p>
    * If <code>false</code> the response procedure will not be executed.
    * 
    * @return The logical value of the socket which determines if the SOCKET 
    *         can receive and handle events.
    */
   /**
    * Queries the SENSITIVE attribute of this widget.
    *
    * @return <code>true</code> if SENSITIVE is set.
    */
   public logical isSensitive();
   
   
   
   /**
    * Java implementation for getting the  SENSITIVE  attribute which
    * contains a <code>logical</code> value that tells if the handle can 
    * receive focus or events.
    * <p>
    * If set to <code>false</code> the response procedure will not be executed.
    * 
    * @param sensitive
    *        The logical value which the socket which determines if the SOCKET 
    *        can receive and handle events to be set.
    */
   public void setSensitive(String sensitive);
   
   /**
    * Java implementation for getting the  SENSITIVE  attribute which
    * contains a <code>logical</code> value that tells if the handle can 
    * receive focus or events
    * <p>
    * If set to <code>false</code> the response procedure will not be executed.
    * 
    * @param sensitive
    *        The logical value which the socket which determines if the SOCKET 
    *        can receive and handle events to be set.
    */
   public void setSensitive(character sensitive);
   
   /**
    * Java implementation for getting the  SENSITIVE  attribute which
    * contains a <code>logical</code> value that tells if the handle can 
    * receive focus or events
    * <p>
    * If set to <code>false</code> the response procedure will not be executed.
    * 
    * @param sensitive
    *        The logical value which the socket which determines if the SOCKET 
    *        can receive and handle events to be set.
    */
   public void setSensitive(logical sensitive);
   
   /**
    * Java implementation for getting the  SENSITIVE  attribute which
    * contains a <code>logical</code> value that tells if the handle can 
    * receive focus or events
    * <p>
    * If set to <code>false</code> the response procedure will not be executed.
    * 
    * @param sensitive
    *        The logical value which the socket which determines if the SOCKET 
    *        can receive and handle events to be set.
    */
   public void setSensitive(boolean sensitive);
   
}
