/*
** Module   : Socket.java
** Abstract : A class for instantiating SOCKET handles.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 CS  20130204 Created initial version.
*/

package com.goldencode.p2j.util;

/**
 * A class for instantiating socket handles.
 */
public class Socket
{
   /**
    * Method for assigning a <code>SocketImpl</code> to the handle defining it 
    * as a socket.
    * 
    * @param socketHandle
    *        The handle to which we will assign the socket
    */
   public static void createSocket(handle socketHandle)
   {
      socketHandle.assign(getSocket());
   }
   
   /**
    * Method which returns a new SocketImpl.
    * 
    * @return a new SocketImpl as a WrappedResource.
    */
   private static WrappedResource getSocket()
   {
      return new SocketImpl();
   }

}
