/*
** Module   : Socket.java
** Abstract : A class for instantiating SERVER-SOCKET handles.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 CS  20130204 Created initial version.
*/

package com.goldencode.p2j.util;

/**
 * A class for instantiating server-socket handles.
 */
public class SocketListener
extends handle
{
   /**
    * Method for assigning a <code>SocketListenerImpl</code> to the handle 
    * defining it as a server-socket.
    * 
    * @param socketHandle
    *        The handle to which we will assign the socket
    */
   public static void createServerSocket(handle socketHandle)
   {
      socketHandle.assign(getServerSocket());
   }
   
   /**
    * Method which returns a new SocketListenerImpl.
    * 
    * @return a new SocketListenerImpl as a WrappedResource.
    */
   private static WrappedResource getServerSocket()
   {
      return new SocketListenerImpl();
   }
}
