/*
** Module   : SocketListenerImpl.java
** Abstract : A class for implementing the SERVER-SOCKET method and attributes
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 CS  20130204 Created initial version.
*/

package com.goldencode.p2j.util;

/**
 * A class for implementing the SERVER-SOCKET method and attributes
 */ 
class SocketListenerImpl 
implements CommonSocketListener,
           WriteableName,
           Sensitive
{
   /** The type of handle object */
   private character type;
   
   /** private data */
   private character privateData;
   
   /**
    * Default constructor which initializes SERVER-SOCKET specific settings.
    */
   public SocketListenerImpl()
   {
      // TODO implement constructor logic EX:
      type = new character("SERVER-SOCKET");
   }

   /**
    * Get the <code>name</code> attribute of handle.
    * 
    * @return   See above.
    */
   public character getName()
   {
      // TODO Implement actual logic
      return new character();
   }
   
   /**
    * Set the <code>name</code> attribute of handle.
    * 
    * @param name
    *        The name attribute to be set.
    */
   public void setName(String name)
   {
      setName(new character(name));
   }
   
   /**
    * Set the <code>name</code> attribute of handle.
    * 
    * @param name
    *        The name attribute to be set.
    */
   public void setName(character name)
   {
      
      
   }

   /**
    * Get the <code>next-sibling</code> attribute of this handle.
    * 
    * @return   See above.
    */
   public handle getNextSibling()
   {
      // TODO Implement actual logic
      return null;
   }

   /**
    * Get the <code>prev-sibling</code> attribute of this handle.
    * 
    * @return   See above.
    */
   public handle getPrevSibling()
   {
      // TODO Implement actual logic
      return null;
   }

   /**
    * Get the <code>private-data</code> attribute of this handle.
    * 
    * @return   See above.
    */
   public character getPrivateData()
   {
      // TODO Implement actual logic
      if(privateData == null)
      {
         privateData = new character();
      }
      return privateData;
   }

   /**
    * Set the <code>private-data</code> attribute of this handle.
    * 
    * @param    data
    *           The new private-data value. 
    */
   public void setPrivateData(character data)
   {
      // TODO Implement actual logic
      privateData = data;
   }

   /**
    * Set the <code>private-data</code> attribute of this handle.
    * 
    * @param    data
    *           The new private-data value. 
    */
   public void setPrivateData(String data)
   {
      // TODO Implement actual logic
      privateData = new character(data);

   }

   /**
    * Get the type of this handle.
    * 
    * @return   See above.
    */
   public character getType()
   {
      return type;
   }

   /**
    * Show a specific error, as this read-only <code>attribute</code> was used
    * on the right-side of an assignment.
    *  
    * @param    attribute
    *           The read-only attribute.
    */
   public void readOnlyError(String attribute)
   {
      // TODO Implement actual logic
   }

   /**
    * Reports if this object is valid for use.  
    *
    * @return   <code>true</code> if we are valid (can be used).
    */
   public boolean isValid()
   {
      // TODO Implement actual logic
      return false;
   }

   /**
    * Reports if this object is unknown.  
    *
    * @return   <code>true</code> if object is unknown.
    */
   public boolean isUnknown()
   {
      // TODO Implement actual logic
      return false;
   }
   
   /**
    * Java implementation for getting the SENSITIVE SERVER-SOCKET attribute
    * which contains a <code>logical</code> value that determines if the SOCKET 
    * can receive events.
    * <p>
    * If <code>false</code> the response procedure will not be executed.
    * 
    * @return The logical value of the socket which determines if the SOCKET 
    *         can receive and handle events.
    */
   public logical isSensitive()
   {
      // TODO Implement the actual logic
      return new logical(true);
   }
  
   /**
    * Java implementation for setting the SENSITIVE SERVER-SOCKET attribute
    * which contains a <code>logical</code> value that determines if the SOCKET 
    * can receive events.
    * <p>
    * If set to <code>false</code> the response procedure will not be executed.
    * 
    * @param sensitive
    *        The logical value which the socket which determines if the SOCKET 
    *        can receive and handle events to be set.
    */
   public void setSensitive(String sensitive)
   {
      setSensitive(new logical(sensitive));
   }
  
   /**
    * Java implementation for setting the SENSITIVE SERVER-SOCKET attribute
    * which contains a <code>logical</code> value that determines if the SOCKET 
    * can receive events.
    * <p>
    * If set to <code>false</code> the response procedure will not be executed.
    * 
    * @param sensitive
    *        The logical value which the socket which determines if the SOCKET 
    *        can receive and handle events to be set.
    */
   public void setSensitive(character sensitive)
   {
      setSensitive(new logical(sensitive));
   }
   
   /**
    * Java implementation for setting the  SENSITIVE SOCKET attribute which
    * contains a <code>logical</code> value that determines if the SOCKET 
    * can receive events.
    * <p>
    * If set to <code>false</code> the response procedure will not be executed.
    * 
    * @param sensitive
    *        The logical value which the socket which determines if the SOCKET 
    *        can receive and handle events to be set.
    */
   public void setSensitive(boolean sensitive)
   {
      setSensitive(new logical(sensitive));
   }
  
   /**
    * Java implementation for setting the  SENSITIVE SOCKET attribute which
    * contains a <code>logical</code> value that determines if the SOCKET 
    * can receive events.
    * <p>
    * If set to <code>false</code> the response procedure will not be executed.
    * 
    * @param sensitive
    *        The logical value which the socket which determines if the SOCKET 
    *        can receive and handle events to be set.
    */
   public void setSensitive(logical sensitive)
   {
      // TODO Implement the actual logic
   }
   
   /**
    * Java implementation for the ENABLE-CONNECTION()  SERVER-SOCKET method, 
    * this will attempt to start listening  on the port specified by the 
    * option argument, and will return <code>true</code> if operation 
    * succeeded, or <code>false</code> otherwise.
    * <p>
    * The following options can be specified as valid ENABLE-CONNECTIONS() 
    * options:
    * <ul>
    *    <li><b>-S port</b> The port to which to connect.
    *    <li><b>-ssl</b> If specified the connection will be made using ssl.
    *    <li><b>-pf config-file-name</b> Specifies the file from which options
    *        will be taken.
    *    <li><b>-qsize maxconn</b> The maximum number of connections to handle 
    *        before refusing extra incoming connections.
    *    <li><b>-keyalias alias</b> The alias for the key and digital 
    *        certificates, default is : default_server.
    *   
    *    <li><b>-keyaliaspasswd pwd</b> The password for the key and digital
    *        certificate. To use always with -keyalias option.
    *    <li><b>-nossesioncache</b> Disables SSL client session cache.
    *    <li><b>-sessiontimeout time</b> The number of seconds before the SSL
    *        client request is timeout, default value is 180..
    * </ul>
    * 
    * @param  option
    *         The set of options that define the enable-connections method.
    * 
    * @return <code>true</code> if operation succeeded, or <code>false</code>
    *         otherwise
    */
   public logical enableConnections(String option)
   {
      return enableConnections(new character(option));
   }
   
   /**
    * Java implementation for the ENABLE-CONNECTION()  SERVER-SOCKET method, 
    * this will attempt to start listening  on the port specified by the 
    * option argument, and will return <code>true</code> if operation 
    * succeeded, or <code>false</code> otherwise.
    * <p>
    * The following options can be specified as valid ENABLE-CONNECTIONS() 
    * options:
    * <ul>
    *    <li><b>-S port</b> The port to which to connect.
    *    <li><b>-ssl</b> If specified the connection will be made using ssl.
    *    <li><b>-pf config-file-name</b> Specifies the file from which options
    *        will be taken.
    *    <li><b>-qsize maxconn</b> The maximum number of connections to handle 
    *        before refusing extra incoming connections.
    *    <li><b>-keyalias alias</b> The alias for the key and digital 
    *        certificates, default is : default_server.
    *   
    *    <li><b>-keyaliaspasswd pwd</b> The password for the key and digital
    *        certificate. To use always with -keyalias option.
    *    <li><b>-nossesioncache</b> Disables SSL client session cache.
    *    <li><b>-sessiontimeout time</b> The number of seconds before the SSL
    *        client request is timeout, default value is 180.
    * </ul>
    * 
    * @param  option
    *         The set of options that define the enable-connections method.
    * 
    * @return <code>true</code> if operation succeeded, or <code>false</code>
    *         otherwise.
    */
   public logical enableConnections(character option)
   {
      // TODO Implement actual logic
      return new logical(true);
   }
   
   /**
    * Java implementation for the DISABLE-CONNECTIONS() SERVER-SOCKET method, 
    * this will stop listening and accepting any new connections, but without
    * interrupting the existing ones that haven't finished, and returns 
    * <code>true</code> if succeeded or  <code>false</code> otherwise.
    * 
    * @return <code>true</code> if the operation succeeded or <code>false</code> 
    *         otherwise.
    */
   public logical disableConnections()
   {
      return new logical(true);
   }
   
   /**
    * Java implementation for the SET-CONNECT-PROCEDURE() SERVER-SOCKET method, 
    * this will set the procedure to execute when a CONNECT event is 
    * received.
    * <p>
    * The set-connect-procedure can also contain a handle to a higher 
    * level procedure which contains the read response procedure (to resolve 
    * any procedure context issues).
    * 
    * @param  procedureName
    *         The name of the procedure we want to set for read response.
    *         
    * @return <code>true</code> if the operation was successful or 
    *         <code>false</code> otherwise.
    */
   public logical setConnectProcedure(String procedureName)
   {
      return setConnectProcedure(new character(procedureName));
   }

   /**
    * Java implementation for the SET-CONNECT-PROCEDURE() SERVER-SOCKET method, 
    * this will set the procedure to execute when a CONNECT event is 
    * received.
    * <p>
    * The set-connect-procedure can also contain a handle to a higher 
    * level procedure which contains the read response procedure (to resolve 
    * any procedure context issues).
    * 
    * @param  procedureName
    *         The name of the procedure we want to set for read response.
    *         
    * @return <code>true</code> if the operation was successful or 
    *         <code>false</code> otherwise.
    */
   public logical setConnectProcedure(character procedureName)
   {
      // TODO Implement actual logic
      return new logical(true);
   }

   /**
    * Java implementation for the SET-CONNECT-PROCEDURE() SERVER-SOCKET method, 
    * this will set the procedure to execute when a CONNECT event is 
    * received.
    * <p>
    * The set-connect-procedure can also contain a handle to a higher 
    * level procedure which contains the read response procedure (to resolve 
    * any procedure context issues).
    * 
    * @param  procedureName
    *         The name of the procedure we want to set for read response.
    * @param  procHandle
    *         The handle for the procedure containing the procedure we want
    *         to set as connect procedure - optional.
    *         
    * @return <code>true</code> if the operation was successful or 
    *         <code>false</code> otherwise.
    */
   public logical setConnectProcedure(String procedureName, handle procHandle)
   {
      return setConnectProcedure(new character(procedureName), procHandle);
   }

   /**
    * Java implementation for the SET-CONNECT-PROCEDURE() SERVER-SOCKET method, 
    * this will set the procedure to execute when a CONNECT event is 
    * received.
    * <p>
    * The set-connect-procedure can also contain a handle to a higher 
    * level procedure which contains the read response procedure (to resolve 
    * any procedure context issues).
    * 
    * @param  procedureName
    *         The name of the procedure we want to set for read response.
    * @param  procHandle
    *         The handle for the procedure containing the procedure we want
    *         to set as connect procedure - optional.
    *         
    * @return <code>true</code> if the operation was successful or 
    *         <code>false</code> otherwise.
    */
   public logical setConnectProcedure(character procedureName,
                                      handle procHandle)
   {
      // TODO Implement actual logic
      return new logical(true);
   }

}
